Diagnostic.Kind (Java SE 26 & JDK 26)
Description: declaration: module: java.compiler, package: javax.tools, interface: Diagnostic, enum: Kind
Keywords: javax.tools.Diagnostic.Kind class

# Enum Class Diagnostic.Kind

java.lang.Object
java.lang.Enum<Diagnostic.Kind>
javax.tools.Diagnostic.Kind

All Implemented Interfaces:
  `Serializable, Comparable<Diagnostic.Kind>, Constable`

Enclosing interface:
  `Diagnostic<S>`

public static enum Diagnostic.Kind extends Enum<Diagnostic.Kind>
Kinds of diagnostics, for example, error or warning. The kind of a diagnostic can be used to determine how the diagnostic should be presented to the user. For example, errors might be colored red or prefixed with the word "Error", while warnings might be colored yellow or prefixed with the word "Warning". There is no requirement that the Kind should imply any inherent semantic meaning to the message of the diagnostic: for example, a tool might provide an option to report all warnings as errors.

Since:
  1.6

- ## Nested Class Summary

  ### Nested classes/interfaces declared in class Enum

  `Enum.EnumDesc<E>`
  Modifier and Type
  Class
  Description
  `static final class`
  `Enum.EnumDesc<E extends Enum<E>>`
  A nominal descriptor for an `enum` constant.

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `ERROR`
  Problem which prevents the tool's normal completion.
  `MANDATORY_WARNING`
  Problem similar to a warning, but is mandated by the tool's specification.
  `NOTE`
  Informative message from the tool.
  `OTHER`
  Diagnostic which does not fit within the other kinds.
  `WARNING`
  Problem which does not usually prevent the tool from completing normally.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static Diagnostic.Kind`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static Diagnostic.Kind[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods declared in class Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`
  Modifier and Type
  Method
  Description
  `protected final Object`
  `clone()`
  Throws CloneNotSupportedException.
  `final int`
  `compareTo(Diagnostic.Kind o)`
  Compares this enum with the specified object for order.
  `final Optional<Enum.EnumDesc<Diagnostic.Kind>>`
  `describeConstable()`
  Returns an enum descriptor `EnumDesc` for this instance, if one can be constructed, or an empty `Optional` if one cannot be.
  `final boolean`
  `equals(Object other)`
  Returns true if the specified object is equal to this enum constant.
  `protected final void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization has been deprecated for removal.
  `final Class<Diagnostic.Kind>`
  `getDeclaringClass()`
  Returns the Class object corresponding to this enum constant's enum type.
  `final int`
  `hashCode()`
  Returns a hash code for this enum constant.
  `final String`
  `name()`
  Returns the name of this enum constant, exactly as declared in its enum declaration.
  `final int`
  `ordinal()`
  Returns the ordinal of this enumeration constant (its position in its enum declaration, where the initial constant is assigned an ordinal of zero).
  `String`
  `toString()`
  Returns the name of this enum constant, as contained in the declaration.
  `static <T extends Enum<T>>
  T`
  `valueOf(Class<T> enumClass, String name)`
  Returns the enum constant of the specified enum class with the specified name.

  ### Methods declared in class Object

  `getClass, notify, notifyAll, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Enum Constant Details

  - ### ERROR

    public static final Diagnostic.Kind ERROR
    Problem which prevents the tool's normal completion.

  - ### WARNING

    public static final Diagnostic.Kind WARNING
    Problem which does not usually prevent the tool from completing normally.

  - ### MANDATORY_WARNING

    public static final Diagnostic.Kind MANDATORY_WARNING
    Problem similar to a warning, but is mandated by the tool's specification. For example, the Java Language Specification mandates warnings on certain unchecked operations and the use of deprecated methods.

  - ### NOTE

    public static final Diagnostic.Kind NOTE
    Informative message from the tool.

  - ### OTHER

    public static final Diagnostic.Kind OTHER
    Diagnostic which does not fit within the other kinds.

- ## Method Details

  - ### values

    public static Diagnostic.Kind[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static Diagnostic.Kind valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null